/**********************************************************************
 * options.h                                                   May 1999
 * Horms                                            horms@vergenet.net.
 * Verge Systems International                    http://vergenet.net./
 *
 * Read in command line options
 * Code based on man getopt(3)
 **********************************************************************/

#ifndef PERDITION_OPTIONS_STIX
#define PERDITION_OPTIONS_STIX

#include <stdio.h>
#include <getopt.h>
#include <string.h>

#include "jain.h"
#include "log.h"

#define DEFAULT_MAPNAME "/etc/perdition/popmap.db"
#define DEFAULT_PORT "110"
#define DEFAULT_USERNAME "nobody"
#define DEFAULT_GROUP "nobody"

typedef struct {
  char * mapname;
  int inetd_mode;
  char * port;
  char * username;
  char * group;
} perdition_options_t;

extern char *optarg;
extern int optind, opterr, optopt;

perdition_options_t perdition_options(int argc, char **argv);
void log_options(perdition_options_t options);
void usage(int exit_status);

#endif
