/**********************************************************************
 * pop3.c                                                    March 1999
 * Horms                                            horms@verge.ing.to.
 * Verge Systems International                http://www.verge.ing.to./
 *
 * Toy pop3 server
 **********************************************************************/

#include "pop3_out.h"

/**********************************************************************
 * Muriel the main funtion
 **********************************************************************/

int pop3_out_authenticate(
  int in_fd, 
  int out_fd, 
  int err_fd, 
  struct passwd *pw
){
  pop3_token *ok;


  if((ok=create_pop3_token(ok))==NULL){
    syslog(LOG_WARNING, "pop3_out_get_pw: create_pop3_token");
    return(-1);
  }
  assign_pop3_token(ok, POP3_OUT_USTRING OK, strlen(OK), -1);

  if(pop3_out_response(in_fd, err_fd, ok)<0){
    return(-1);
  }

  if(write_strings(out_fd, 3, "USER ", pw->pw_name, "\n")<0){
    syslog(LOG_WARNING, "pop3_out_get_pw: write_strings");
    return(-1);
  }

  if(pop3_out_response(in_fd, err_fd, ok)<0){
    return(-1);
  }

  if(write_strings(out_fd, 3, "PASS ", pw->pw_passwd, "\n")<0){
    syslog(LOG_WARNING, "pop3_out_get_pw: write_strings");
    return(-1);
  }

  if(pop3_out_response(in_fd, err_fd, ok)<0){
    return(-1);
  }

  return(1);
}
  

int pop3_out_response(int in_fd, int out_fd, pop3_token *desired_token){
  int status;
  queue *q;
  pop3_token *token;

  if((q=read_pop3_line(in_fd, q))==NULL){
    syslog(LOG_WARNING, "pop3_out_response: read_pop3_line");
    return(-1);
  }
  if((q=pop(q, (queue_t *)&token))==NULL){
    syslog(LOG_WARNING, "pop3_out_response: pop");
    return(-1);
  }
  destroy_queue(q, DESTROY_POP3_TOKEN);

  status=pop3_token_cmp(desired_token, token);
  if(status!=0){
    sleep(POP3_OUT_ERR_SLEEP);
    if(write_strings(out_fd, 2, ERR, " Re-Authentecation Failure\n")<0){
      syslog(LOG_WARNING, "pop3_out_response: write_strings");
      return(-1);
    }
    status=-1;
  }
  else{
    status=0;
  }
  destroy_pop3_token(token);
  return(status);
}
