/**********************************************************************
 * queue.h                                                   March 1999
 * Horms                                            horms@verge.ing.to.
 * Verge Systems International                http://www.verge.ing.to./
 *
 **********************************************************************/

#ifndef QUEUEBERT
#define QUEUEBERT

#include <stdlib.h>
#include <stdio.h>
#include "log.h"

typedef void * queue_t;

struct struct_queue_member{
  struct struct_queue_member *next;
  struct struct_queue_member *prev;
  queue_t value;
};

typedef struct struct_queue_member queue_member;

typedef struct{
  queue_member *first;
  queue_member *last;
  int size;
}queue;

queue *push(queue *q, queue_t value, void (*destroy_queue_t)(const void *));
queue *pop(queue *q, queue_t *value);
queue *create_queue(queue *q);
void destroy_queue(queue *q, void (*destroy_queue_t)(const void *));
int queue_length(queue *q);
 

#endif
